#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <regex>
#include "Validator.h"
using namespace std;

// PARTS OF VALIDATOR BY DAVID RUSSEL SOURCED FROM LECTURE DATED SEPTEMBER 15, 2016
bool Validator::input(string* input)
{
	char tmpKey;
	const static int maxLength = 128;
	do {
		tmpKey = _getch();
		if ((tmpKey >= 48 && tmpKey <= 57) || (tmpKey >= 65 && tmpKey <= 90) || (tmpKey >= 97 && tmpKey <= 122) || tmpKey == 32 /*[SPACE]*/) // Ensure letters, numbers or spaces.
		{
			if (maxLength > (*input).length()) {
				(*input) += tmpKey;
				printf("%c", tmpKey);
			}
		}
		else if (tmpKey == 8 && (*input).length() > 0) {
			(*input).erase((*input).length() - 1, 1);
			printf("\b \b");
		}
		else if (tmpKey == -32) {
			_getch();
		}
		else if (tmpKey == 27 /*[ESCAPE]*/) {
			return false;
		}
	} while (tmpKey != 13);

	printf("\n");
	return true;
};

//Regex to verify student name
bool Validator::nameVerify(string input) {
	regex testRegex("^([a-zA-Z ]+)\\b$");
	return regex_search(input, testRegex);
}

//Regex to verify course name
bool Validator::courseVerify(string input) {
	regex testRegex("^([a-zA-Z0-9 ]+)\\b$");
	return regex_search(input, testRegex);
}

//Regex to verify course name
bool Validator::yesNoVerify(string input) {
	regex testRegex("^([y|Y|n|N])\\b$");
	return regex_search(input, testRegex);
}